#ifndef _ELM_INTERFACE_ATSPI_ACTION_EO_H_
#define _ELM_INTERFACE_ATSPI_ACTION_EO_H_

/**

 */
#define ELM_INTERFACE_ATSPI_ACTION_CLASS elm_interface_atspi_action_class_get()

const Eo_Class *elm_interface_atspi_action_class_get(void) EINA_CONST;

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
/**
 * @def elm_interface_atspi_action_name_get
 *
 * Gets action name for given id
 *
 * @param[in] id No description supplied.
 *
 */
EAPI const char * elm_interface_atspi_action_name_get(int id);
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
/**
 * @def elm_interface_atspi_action_localized_name_get
 *
 * Gets localized action name for given id
 *
 * @param[in] id No description supplied.
 *
 */
EAPI const char * elm_interface_atspi_action_localized_name_get(int id);
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
/**
 * @def elm_interface_atspi_action_description_set
 *
 * Sets action description for given id
 *
 * @param[in] id No description supplied.
 * @param[in] description No description supplied.
 *
 */
EAPI Eina_Bool  elm_interface_atspi_action_description_set(int id, const char *description);
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
/**
 * @def elm_interface_atspi_action_description_get
 *
 * Gets action description for given id
 *
 * @param[in] id No description supplied.
 *
 */
EAPI const char * elm_interface_atspi_action_description_get(int id);
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
/**
 * @def elm_interface_atspi_action_actions_get
 *
 * Get list of available widget actions
 *
 *
 */
EAPI Eina_List * elm_interface_atspi_action_actions_get(void);
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
/**
 * @def elm_interface_atspi_action_action_do
 *
 * Performs action on given widget.
 *
 * @param[in] id No description supplied.
 *
 */
EAPI Eina_Bool  elm_interface_atspi_action_action_do(int id);
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
/**
 * @def elm_interface_atspi_action_keybinding_get
 *
 * Gets configured keybinding for specific action and widget.
 *
 * @param[in] id No description supplied.
 *
 */
EAPI const char * elm_interface_atspi_action_keybinding_get(int id);
#endif


#endif